#needed https://gitlab.inria.fr/scotch/scotch/-/issues/26
%define         _disable_ld_no_undefined 1

#to remain backward compatible with our previous installs
%define         mpi_prefix		 	 %{_libdir}/mpi/gcc/openmpi

%define         majornum                 	 7
%define        	minornum			 0

%define		libscotchname            	 %mklibname %{name} %{majornum}
%define		libscotchdevname	 	 %mklibname -d %{name}
%define		libscotchmetisdevname	 	 %mklibname -d %{name}-metis

%define		libptscotchname              	 %mklibname pt%{name}-openmpi %{majornum}
%define		libptscotchdevname       	 %mklibname -d pt%{name}-openmpi
%define  	libptscotchparmetisdevname	 %mklibname -d pt%{name}-parmetis-openmpi

%ifnarch %arm32 %ix86
%bcond_without  mpi
%else
%bcond_with     mpi
%endif

Summary:        Graph, mesh and hypergraph partitioning library
License:        CeCILL
Group:          Development/C++
Name:           scotch
Version:        7.0.5
Release:        %mkrel 1
Url:            https://gitlab.inria.fr/scotch
Source0:        https://gitlab.inria.fr/scotch/scotch/-/archive/v%{version}/%{name}-v%{version}.tar.bz2
Source1:        scotch-Makefile.inc.in
#from fedora
#Patch0:         scotch-7.0.4-installdirs.patch
#man files in mandir
#Patch1:         scotch-v7.0.4-mandir.patch
#add a soversion, upstream does not seem to care
#Patch2:         scotch-v7.0.4-soname.patch

BuildRequires:  cmake
BuildRequires:  bison
BuildRequires:  fdupes
BuildRequires:  flex
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  gcc-gfortran
BuildRequires:  make
BuildRequires:  pkgconfig(zlib)
BuildRequires:  pkgconfig(bzip2)
%if %{with mpi}
BuildRequires:  pkgconfig(ompi)
%endif

%description
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering.


%package -n %{libscotchname}
Summary:        Graph, mesh and hypergraph partitioning library
Group:          Development/C++
Requires:       %{name} = %{version}
Obsoletes:      libscotch0 < 7.0.0

%description -n %{libscotchname}
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering.

%package -n %{libscotchdevname}
Summary:        Development libraries for scotch
Group:          Development/C++
Provides:       scotch-devel = %{version}-%{release}
Requires:       gcc-gfortran
Requires:       %{libscotchname} = %{version}-%{release}
Obsoletes:      libscotch-devel < 7.0.0
Obsoletes:      libscotch-devel-static < 7.0.0

%description -n %{libscotchdevname}
This package contains development libraries for libscotch.


%package -n %{libscotchmetisdevname}
Summary:        Development libraries for scotch
Group:          Development/C++
Conflicts:      metis-devel
Requires:       %{libscotchdevname} = %{version}-%{release}
Obsoletes:      libscotch-metis-devel < 7.0.0

%description -n %{libscotchmetisdevname}
This package contains the devel libraries and header file in the case
scotch is used as a replacement of the metis library.

%if %{with mpi}
%package -n ptscotch-openmpi
Summary:        Graph, mesh and hypergraph partitioning library
Group:          Development/C++
Requires:       %{name} = %{version}

%description -n ptscotch-openmpi
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering.


%package -n %{libptscotchname}
Summary:        Graph, mesh and hypergraph partitioning library
Group:          Development/C++
Requires:       %{libscotchname} = %{version}-%{release}
Obsoletes:      libptscotch0-openmpi < 7.0.0

%description -n %{libptscotchname}
Scotch is a software package for graph and mesh/hypergraph partitioning and
sparse matrix ordering.

%package -n %{libptscotchdevname}
Summary:        Development libraries for scotch
Group:          Development/C++
Provides:       ptscotch-openmpi-devel = %{version}-%{release}
Requires:       gcc-gfortran
Requires:       openmpi-devel
Requires:       %{libptscotchname} = %{version}-%{release}
Requires:       %{libscotchdevname} = %{version}-%{release}
Obsoletes:      libptscotch-openmpi-devel < 7.0.0
Obsoletes:	libptscotch-openmpi-devel-static < 7.0.0

%description -n %{libptscotchdevname}
This package contains development libraries for libscotch.


%package -n %{libptscotchparmetisdevname}
Summary:        Development libraries for scotch
Group:          Development/C++
Requires:       %{libptscotchdevname} = %{version}-%{release}
Obsoletes:      libptscotch-parmetis-openmpi-devel < 7.0.0
Provides:       libptscotch-parmetis-openmpi-devel = %{version}-%{release}

%description -n %{libptscotchparmetisdevname}
This package contains the devel libraries and header file in the case
ptscotch is used as a replacement of the parmetis library.
%endif


%prep
%setup -q -n scotch-v%{version}
%autopatch -p1

%__mkdir build
%__mkdir build_mpi




%build
%cmake	-B ./build  \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_PTSCOTCH=OFF \
	-DCOMMON_PTHREAD:BOOL=ON \
	-DSCOTCH_PTHREAD:BOOL=ON \
	-DBUILD_LIBSCOTCHMETIS=ON \
	-DCMAKE_INSTALL_INCLUDEDIR=%{_includedir}	

%__cmake --build build %{?_smp_mflags} --verbose


%if %{with mpi}

%cmake	-B ./build_mpi \
        -DBUILD_SHARED_LIBS=ON \
	-DBUILD_PTSCOTCH=ON \
	-DCOMMON_PTHREAD:BOOL=ON \
	-DSCOTCH_PTHREAD:BOOL=ON \
	-DBUILD_LIBSCOTCHMETIS=ON \
	-DCMAKE_CXX_COMPILER=%{_bindir}/mpic++ \
	-DCMAKE_C_COMPILER=%{_bindir}/mpicc \
	-DCMAKE_Fortran_COMPILER=%{_bindir}/mpif90 \
        -DCMAKE_INSTALL_PREFIX=%{mpi_prefix} \
	-DCMAKE_INSTALL_INCLUDEDIR=%{mpi_prefix}/include \
	-DCMAKE_INSTALL_LIBDIR=%{mpi_prefix}/%{_lib}

%__cmake --build build_mpi %{?_smp_mflags} --verbose

%endif

%install
%if %{with mpi}
DESTDIR="%{buildroot}" %__cmake --install build_mpi
%endif
DESTDIR="%{buildroot}" %__cmake --install build

# Convert the license files to utf8
pushd doc
iconv -f iso8859-1 -t utf-8 < CeCILL-C_V1-en.txt > CeCILL-C_V1-en.txt.conv
iconv -f iso8859-1 -t utf-8 < CeCILL-C_V1-fr.txt > CeCILL-C_V1-fr.txt.conv
mv -f CeCILL-C_V1-en.txt.conv CeCILL-C_V1-en.txt
mv -f CeCILL-C_V1-fr.txt.conv CeCILL-C_V1-fr.txt
popd

%if %{with mpi}
#(eatdirt) ld path for ptscotch
%{__mkdir_p} %{buildroot}%{_sysconfdir}/ld.so.conf.d
echo %{mpi_prefix}/%{_lib} > %{buildroot}%{_sysconfdir}/ld.so.conf.d/ptscotch.conf
%endif

#default metis to v5
pushd %{buildroot}%{_libdir}
ln -s libscotchmetisv5.so libscotchmetis.so
ln -s libscotchmetisv5.so.%{majornum}.%{minornum} libscotchmetis.so.%{majornum}.%{minornum}
popd

%if %{with mpi}
#default parmetis to v3
pushd %{buildroot}%{mpi_prefix}/%{_lib}
ln -s libptscotchparmetisv3.so libptscotchparmetis.so
ln -s libptscotchparmetisv3.so.%{majornum}.%{minornum} libptscotchparmetis.so.%{majornum}.%{minornum}
popd
%endif

%fdupes -s %{buildroot}%{_bindir}

%files
%doc README.txt doc/scotch*.pdf doc/CeCILL-*
%{_bindir}/*
%{_mandir}/man1/*.1*


%files -n %{libscotchname}
%{_libdir}/libscotch.so.%{majornum}{,.*}
%{_libdir}/libscotcherr.so.%{majornum}{,.*}
%{_libdir}/libscotcherrexit.so.%{majornum}{,.*}
%{_libdir}/libscotchmetis.so.%{majornum}{,.*}
%{_libdir}/libscotchmetisv3.so.%{majornum}{,.*}
%{_libdir}/libscotchmetisv5.so.%{majornum}{,.*}
%{_libdir}/libesmumps.so.%{majornum}{,.*}
%{_libdir}/libptesmumps.so.%{majornum}{,.*}

%files -n  %{libscotchdevname}
%{_libdir}/libscotch.so
%{_libdir}/libscotcherr.so
%{_libdir}/libscotcherrexit.so
%{_libdir}/libesmumps.so
%{_libdir}/libptesmumps.so
%{_includedir}/*.h
%exclude %{_includedir}/metis.h
%exclude %{_includedir}/metisf.h
%{_libdir}/cmake/scotch/*
%exclude %{_libdir}/cmake/scotch/scotchmetis*


%files -n %{libscotchmetisdevname}
%{_libdir}/libscotchmetis.so
%{_libdir}/libscotchmetisv3.so
%{_libdir}/libscotchmetisv5.so
%{_includedir}/metis.h
%{_includedir}/metisf.h
%{_libdir}/cmake/scotch/scotchmetis*


%if %{with mpi}

%files -n ptscotch-openmpi
%doc README.txt  doc/ptscotch*.pdf doc/CeCILL-*
%{_libdir}/mpi/gcc/openmpi/bin/*
%{_libdir}/mpi/gcc/openmpi/share/man/man1/*

%files -n %{libptscotchname}
%{_sysconfdir}/ld.so.conf.d/ptscotch.conf
%{mpi_prefix}/%{_lib}/libscotch.so.%{majornum}{,.*}
%{mpi_prefix}/%{_lib}/libscotcherr.so.%{majornum}{,.*}
%{mpi_prefix}/%{_lib}/libscotcherrexit.so.%{majornum}{,.*}
%{mpi_prefix}/%{_lib}/libscotchmetisv3.so.%{majornum}{,.*}
%{mpi_prefix}/%{_lib}/libscotchmetisv5.so.%{majornum}{,.*}
%{mpi_prefix}/%{_lib}/libptscotch.so.%{majornum}{,.*}
%{mpi_prefix}/%{_lib}/libptscotcherr.so.%{majornum}{,.*}
%{mpi_prefix}/%{_lib}/libptscotcherrexit.so.%{majornum}{,.*}
%{mpi_prefix}/%{_lib}/libptscotchparmetisv3.so.%{majornum}{,.*}
%{mpi_prefix}/%{_lib}/libptscotchparmetis.so.%{majornum}{,.*}
%{mpi_prefix}/%{_lib}/libesmumps.so.%{majornum}{,.*}
%{mpi_prefix}/%{_lib}/libptesmumps.so.%{majornum}{,.*}

%files -n %{libptscotchdevname}
%{mpi_prefix}/%{_lib}/libscotch.so
%{mpi_prefix}/%{_lib}/libscotcherr.so
%{mpi_prefix}/%{_lib}/libscotcherrexit.so
%{mpi_prefix}/%{_lib}/libscotchmetisv3.so
%{mpi_prefix}/%{_lib}/libscotchmetisv5.so
%{mpi_prefix}/%{_lib}/libptscotch.so
%{mpi_prefix}/%{_lib}/libptscotcherr.so
%{mpi_prefix}/%{_lib}/libptscotcherrexit.so
%{mpi_prefix}/%{_lib}/libesmumps.so
%{mpi_prefix}/%{_lib}/libptesmumps.so
%{mpi_prefix}/include/*.h
%exclude %{mpi_prefix}/include/parmetis.h
%{mpi_prefix}/%{_lib}/cmake/scotch/*
%exclude %{mpi_prefix}/%{_lib}/cmake/scotch/ptscotchparmetis*

%files -n %{libptscotchparmetisdevname}
%{mpi_prefix}/%{_lib}/libptscotchparmetis.so
%{mpi_prefix}/%{_lib}/libptscotchparmetisv3.so
%{mpi_prefix}/include/parmetis.h
%{mpi_prefix}/%{_lib}/cmake/scotch/ptscotchparmetis*

%endif


%changelog
* Mon Sep 02 2024 eatdirt <eatdirt> 7.0.5-1.mga10
+ Revision: 2092687
- Update to version 7.0.5

* Sat Feb 24 2024 eatdirt <eatdirt> 7.0.4-5.mga10
+ Revision: 2043826
- Add missing provides for parmetis

* Thu Feb 22 2024 eatdirt <eatdirt> 7.0.4-4.mga10
+ Revision: 2043123
- Rebuild for new openmpi

* Sun Feb 18 2024 eatdirt <eatdirt> 7.0.4-2.mga10
+ Revision: 2042469
- Add more Obsoletes

* Sat Feb 17 2024 eatdirt <eatdirt> 7.0.4-1.mga10
+ Revision: 2042090
- Use mpi compilers for pt version
- Clean libnames
- Upgrade to version 7.0.4 and rework spec file from scratch
+ wally <wally>
- more linker flag fixes

* Mon Sep 25 2023 wally <wally> 6.1.3-2.mga10
+ Revision: 1990868
- drop unneeded post(un) scriptlets
- build using our linker flags

* Thu May 05 2022 eatdirt <eatdirt> 6.1.3-1.mga9
+ Revision: 1856397
- Update to version 6.1.3

* Wed Mar 30 2022 umeabot <umeabot> 6.1.2-2.mga9
+ Revision: 1833965
- Mageia 9 Mass Rebuild

* Tue Dec 14 2021 eatdirt <eatdirt> 6.1.2-1.mga9
+ Revision: 1762077
- Update to version 6.1.2

* Fri Aug 27 2021 eatdirt <eatdirt> 6.1.1-2.mga9
+ Revision: 1742858
- Add conflicts with metis-devel

* Fri Aug 27 2021 eatdirt <eatdirt> 6.1.1-1.mga9
+ Revision: 1742822
- Upgrade to version 6.1.1

* Mon Mar 08 2021 eatdirt <eatdirt> 6.0.9-2.mga9
+ Revision: 1700619
- Add ld conf file for ptscotch-openmpi libraries

* Sun Mar 22 2020 eatdirt <eatdirt> 6.0.9-1.mga8
+ Revision: 1558940
- Upgrade to version 6.0.9

* Fri Feb 14 2020 umeabot <umeabot> 6.0.6-3.mga8
+ Revision: 1516898
- Mageia 8 Mass Rebuild

* Sun Sep 23 2018 umeabot <umeabot> 6.0.6-2.mga7
+ Revision: 1300961
- Mageia 7 Mass Rebuild

* Wed Aug 01 2018 eatdirt <eatdirt> 6.0.6-1.mga7
+ Revision: 1246661
- Upgrade to version 6.0.6

* Fri May 18 2018 eatdirt <eatdirt> 6.0.4-6.mga7
+ Revision: 1230331
- Rebuild for new openmpi

* Sun Oct 08 2017 eatdirt <eatdirt> 6.0.4-5.mga7
+ Revision: 1170287
- Rebuild for new openmpi

* Mon Sep 11 2017 tv <tv> 6.0.4-4.mga7
+ Revision: 1152743
- rebuild for new libgfortran

* Fri Dec 02 2016 tmb <tmb> 6.0.4-3.mga6
+ Revision: 1071634
- rebuild for new openmpi

* Wed Feb 17 2016 umeabot <umeabot> 6.0.4-2.mga6
+ Revision: 962762
- Mageia 6 Mass Rebuild

* Thu Nov 26 2015 philippem <philippem> 6.0.4-1.mga6
+ Revision: 906224
- update to 6.0.4

* Wed Sep 30 2015 daviddavid <daviddavid> 6.0.0-4.mga6
+ Revision: 885264
- rebuild for new openmpi 1.10.0

* Wed Oct 15 2014 umeabot <umeabot> 6.0.0-3.mga5
+ Revision: 746565
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 6.0.0-2.mga5
+ Revision: 689076
- Mageia 5 Mass Rebuild

* Fri Nov 29 2013 philippem <philippem> 6.0.0-1.mga4
+ Revision: 554079
- fix requires

* Thu Nov 28 2013 philippem <philippem> 6.0.0-0.mga4
+ Revision: 554001
- imported package scotch

